
#include <iostream>

#include "TSystem.h"
#include "TStyle.h"
#include "TROOT.h"
#include "TH1.h"
#include "TCanvas.h"

#include "TArtEventStore.h"
#include "TArtRawEventObject.h"

#include "TArtMethodManager.hh"

#include "TArtDataNEBULA.hh"
#include "TArtParameterNEBULA.hh"
#include "TArtMethodLoadNEBULA.hh"
#include "TArtMethodAnalysisNEBULA.hh"

void test_compile()
{
  TArtDataNEBULA *datanebula = new TArtDataNEBULA;
  TArtParameterNEBULA *parameternebula = new TArtParameterNEBULA("db/NEBULA.xml");

  TArtMethodLoadNEBULA *lmn = new TArtMethodLoadNEBULA(datanebula, parameternebula);
  TArtMethodAnalysisNEBULA *amn = new TArtMethodAnalysisNEBULA(datanebula);

  TArtMethodManager am;
  am.AddMethodLoad(lmn);
  am.AddMethodAnalysis(amn);

  TArtEventStore *estore = new TArtEventStore();
  TArtRawEventObject *rawevent = new TArtRawEventObject();
  estore->Initialize(rawevent); 
  estore->Open("ridf/test.ridf");

  TH1* hadc = new TH1I("hadc", "hist of adc", 4100, 0, 4100);
  TH1* htdc = new TH1I("htdc", "hist of tdc", 4100, 0, 4100);

  int neve = 0;
  while(estore->GetNextEvent() && neve<10000){
    std::cout << "AnaNEBULA: " << ++neve << std::endl;

    am.DoAll(rawevent);

    TArtDataNEBULA::TArtDataNEBULAInnerMap::iterator it = datanebula->InnerMapBegin();
    while(it !=  datanebula->InnerMapEnd()){
      hadc->Fill(it->second.fADC);
      htdc->Fill(it->second.fTDC);
      ++it;
    }

    rawevent->Clear();
  }

  TCanvas* canvas = TCanvas::MakeDefCanvas();
  canvas->Divide(1,2);
  canvas->cd(1);
  hadc->Draw();
  canvas->cd(2);
  htdc->Draw();
}
