#ifndef TARTHISTMANAGER_HH
#define TARTHISTMANAGER_HH

class TH1;
class TDirectory;
class TArtObjLinkManager;

//Pointer of current hist.
//This pointer is valid after public method of TArtHistManager has been called.
extern TH1* gTH1;

class TArtHistManager
{
public:
  //////////////////////////////////////////////
  //----  these method do not change gTH1 ----// 
  //////////////////////////////////////////////
  //Read all TH1 object in file(filename) to current directory.
  static void ReadHist(char *filename);
  //Write all TH1 object in current directory to file(filename).
  static void WriteHist(char *filename);
  //Delete all TH1 object in current directory.
  static void DeleteHist();

  //print list of hist in current directory.
  static void PrintListOfHist();

  //find hist by id.
  static TH1* FindHist(int id);
  //find id by hist.
  static int FindId(TH1* hist);
  /////////////////////////////////////////////

  //draw hist by id
  static TH1* DrawHist(int id);
  static TH1* DrawCurrentHist();
  static TH1* DrawNextHist();
  static TH1* DrawPreviousHist();
  //draw hist and set to gTH1.
  static TH1* DrawHist(TH1* hist);

  static TH1* InsertAfterHist(TH1* hist, TH1* histafter);

  ///////////////////////////////////////////////////////////////////////
  //---- methods under here control fArtObjLinkManager explicitly ---- //
  ///////////////////////////////////////////////////////////////////////
  //return gTH1.
  static TH1* GetHist();
  //if you want to change gTH1, better to use this method
  static TH1* SetHist(TH1* hist);
  //set gTH1 to 0
  static void ResetHist();

  //cyclic method. if you want to break endless loop, refer PrintListOfHist.
  static TH1* GetNextHist();
  static TH1* GetPreviousHist();

  static TH1* GetFirstHist();
  static TH1* GetLastHist();
  ///////////////////////////////////////////////////////////////////////

private:
  //control objlink of gDirectory
  static TArtObjLinkManager* fArtObjLinkManager;
};

#endif
