
#include "TArtAlias.hh"
#include "TArtHistManager.hh"
#include "TArtCanvasManager.hh"
#include "TArtSimpleFunction.hh"
#include "TArtExec.hh"

void fetch(char* filename){TArtHistManager::ReadHist(filename);}
void hstore(char* filename){TArtHistManager::WriteHist(filename);}
void clear(){TArtHistManager::DeleteHist();}

void ls(){TArtHistManager::PrintListOfHist();}

void ht(int idstart, int idend){cd(1);hht(idstart, idend);}
void ht(int id){cdn();hht(id);}
void htp(){cdn();hhtp();}
void hn(){cdn();hhn();}
void hb(){cdn();hhb();}

void hht(int idstart, int idend)
{for(int i = idstart; i <= idend && i-idstart < TArtCanvasManager::GetSubpadNumber(); ++i)
    {hht(i);cdn();}}
void hht(int id){TArtHistManager::DrawHist(id);}
void hhtp(){TArtHistManager::DrawCurrentHist();}
void hhn(){TArtHistManager::DrawNextHist();}
void hhb(){TArtHistManager::DrawPreviousHist();}

void lg(){lgx();lgy();lgz();}
void ln(){lnx();lny();lnz();}
void lgx(){TArtCanvasManager::SetLogx(1);}
void lgy(){TArtCanvasManager::SetLogy(1);}
void lgz(){TArtCanvasManager::SetLogz(1);}
void lnx(){TArtCanvasManager::SetLogx(0);}
void lny(){TArtCanvasManager::SetLogy(0);}
void lnz(){TArtCanvasManager::SetLogz(0);}

void size(UInt_t ww, UInt_t wh){TArtCanvasManager::SetWindowSize(ww, wh);}
void cd(Int_t subpadnumber){TArtCanvasManager::cd(subpadnumber);}
void cdn(){TArtCanvasManager::cdnext();}
void cdb(){TArtCanvasManager::cdprev();}
void zone(Int_t nx, Int_t ny, Float_t xmargin, Float_t ymargin, Int_t color)
{TArtCanvasManager::Divide(nx, ny, xmargin, ymargin, color);}

Double_t xval(){return TArtExec::GXValue();}
Double_t yval(){return TArtExec::GYValue();}
void xyval(){Double_t x,y;TArtExec::GXYValue(x, y);}
void xzoom(){TArtSimpleFunction::GRangeX();}
void yzoom(){TArtSimpleFunction::GRangeY();}
void xyzoom(){TArtSimpleFunction::GRangeXY();}
void xblow(){TArtSimpleFunction::GBlowX();}
void yblow(){TArtSimpleFunction::GBlowY();}
void xyblow(){TArtSimpleFunction::GBlowXY();}
void cpro(){TArtSimpleFunction::CutGHist();}

void figa(){fitg();}
TFitResultPtr fit(const char* formula, Option_t* option, Option_t* goption, Double_t xmin, Double_t xmax){return TArtSimpleFunction::Fit(formula, option, goption, xmin, xmax);}
TFitResultPtr fitp(int n, Option_t* option, Option_t* goption, Double_t xmin, Double_t xmax){return TArtSimpleFunction::FitPolynomial(n, option, goption, xmin, xmax);}
TFitResultPtr fite(Option_t* option, Option_t* goption, Double_t xmin,  Double_t xmax){return TArtSimpleFunction::FitExponential(option, goption, xmin, xmax);}
TFitResultPtr fitg(Option_t* option, Option_t* goption, Double_t xmin,  Double_t xmax){return TArtSimpleFunction::FitGaussian(option, goption, xmin, xmax);}
TFitResultPtr fitl(Option_t* option, Option_t* goption, Double_t xmin,  Double_t xmax){return TArtSimpleFunction::FitLandau(option, goption, xmin, xmax);}

void pfx(){TArtSimpleFunction::ProfileX();}
void pfy(){TArtSimpleFunction::ProfileY();}
void prx(){TArtSimpleFunction::ProjectionX();}
void pry(){TArtSimpleFunction::ProjectionY();}
void bnx(double firstx, double lastx, Option_t* option){TArtSimpleFunction::BanX(firstx, lastx, option);}
void bny(double firsty, double lasty, Option_t* option){TArtSimpleFunction::BanY(firsty, lasty, option);}
void zoom(double firstx, double lastx, double firsty, double lasty, double firstz, double lastz)
{TArtSimpleFunction::Range(firstx, lastx, firsty, lasty, firstz, lastz);}
void zoomx(double firstx, double lastx){TArtSimpleFunction::RangeX(firstx, lastx);}
void zoomy(double firsty, double lasty){TArtSimpleFunction::RangeY(firsty, lasty);}
void zoomz(double firstz, double lastz){TArtSimpleFunction::RangeZ(firstz, lastz);}
void blow(double firstx, double lastx, double firsty, double lasty, double firstz, double lastz)
{TArtSimpleFunction::Blow(firstx, lastx, firsty, lasty, firstz, lastz);}
void blowx(double firstx, double lastx){TArtSimpleFunction::BlowX(firstx, lastx);}
void blowy(double firsty, double lasty){TArtSimpleFunction::BlowY(firsty, lasty);}
void blowz(double firstz, double lastz){TArtSimpleFunction::BlowZ(firstz, lastz);}

void mami(double min, double max){TArtSimpleFunction::MinMax(min, max);}
